<?php
// Word Press Navigation List Module
// Author: Greg Bellucci (greg@gbellucci.us)
// Date: 11/2006
// Version: 1.2
// Desc: This is the companion sidebar widget for the Word Press Navigation Tool.
// Use this widget to display your navigation lists in your widgetized theme. This widget
// works with Sidebar Modules Plugin version 1.0 and higher from http://nybblelabs.org.uk/
// and K2. This module should be installed in the SBM modules directory.
//
function navt_module($args) {

	extract($args);

    if( function_exists('navt_getlist') ) {
		$listName = sbm_get_option('navt_list');
        echo($before_module . $before_title . $title . $after_title);
        navt_getlist($listName);
        echo($after_module);
    }
}

function navt_sidebar_module_control() {

    if( !function_exists('navt_getlist') ) { ?>
        <p style="color:red;">The NAVT Plugin is not installed.</p> <?php
    }
    else {

        if(isset($_POST['navt_list']))
	       sbm_update_option('navt_list', $_POST['navt_list']);

        $ddlist = '';
        $no_groups = 1;
        $curItem = sbm_get_option('navt_list');

        if(function_exists('navt_getAllLists')) {
            $groups = navt_getAllLists();
            if( $groups != null) {
                $grps = explode(',',$groups);
                if( is_array($grps) ) {
                    $ddlist = sprintf("<select id=\"navt_list\" name=\"navt_list\">\n");
                    $curItem = $curItem == '' ? $grps[0]: $curItem;
                    for( $i = 0; $i < count($grps); $i++ ) {
                        $select = ($curItem == $grps[$i] ? ' selected="selected"':'');
                        $ddlist .= sprintf("<option value=\"%s\"%s>%s</option>\n", $grps[$i], $select, $grps[$i]);
                    }
                    $no_groups = 0;
                    $ddlist .= sprintf("</select>\n"); ?>

                    <p><label for="navt_list"><?php _e('Navigation Group:', 'navt_domain'); ?></label>
	               <?php echo $ddlist;?></p><?php
                }
            }

            if( $no_groups ) {?><p style="color:red;">Navigation Lists have not been created.</p><?php }
        }
    }
}


register_sidebar_module('NAVT Plugin Companion Module', 'navt_module', 'sb_navt_list', array('navt_list' => '' ));
register_sidebar_module_control('NAVT Plugin Companion Module', 'navt_sidebar_module_control');
?>