/*
* NAVT-TIP
* Tips for NAVT Plugin built on jTip By Cody Lindley (http://www.codylindley.com)
* Under an Attribution, Share Alike License
* JTip is built on top of the very light weight jquery library.
*/

/* NAVT-TIP Greg Bellucci
 *  - does not remove the tip on hover out - instead the tip html provides a close button and the necessary javascript
 *    to register the click event.
 *  - modification to determine which side of the link the tip is displayed on.
 *  - if a #NT element is present in the dom - it will not create a new one - this is in case the user rolls over the trigger
 *    more than once.
 *  - renamed $ to jQuery
 */

function NT_activate(){
    jQuery("a.navt-jTip")
    .hover(
        function(){
            NT_show(this.href,this.id,this.name)
        },
        function(){/* gab: removed - jQuery('#NT').remove()*/
        })
    .click(function(){
        return false
    });
}
function NT_deactivate() {
    jQuery("a.navt-jTip").unbind();
}


function NT_show(url,linkId,title) {

    // - gab: added -  prevent more than one #NT from being created
    var opened = jQuery('#NT');
    if( opened[0] != null ) return;
    // -----------------------------

    if(title == false)title="&nbsp;";
    var de = document.documentElement;
    var w = self.innerWidth || (de && de.clientWidth) || document.body.clientWidth;
    var hasArea = w - getAbsoluteLeft(linkId);
    var clickElementy = getAbsoluteTop(linkId) - 3; //set y position

    var queryString = url.replace(/^[^\?]+\??/,'');
    var params = parseQuery( queryString );
    if(params['width'] === undefined){params['width'] = 250};
    if(params['link'] !== undefined){
        jQuery('#' + linkId).bind('click',function(){window.location = params['link']});
        jQuery('#' + linkId).css('cursor','pointer');
    }

    // ------------------------------------------------------------
    // gab: added - Always choose the right side if the x position is negative
    var ex = getAbsoluteLeft(linkId) - ((params['width']*1) + 15);
    var rside = ( ex < 1 ) ? 1: 0;
    // -------------------------------------------------------------

    // ----------------------------------------
    //gab: removed -- if(hasArea > ((params['width']*1)+75)){
    // ----------------------------------------
    if( rside ) { // gab: added
        // choose the right side
        jQuery("body").append("<div id='NT' style='width:"+params['width']*1+"px'><div id='NT_arrow_left'></div><div id='NT_close_left'>"+title+"</div><div id='NT_copy'><div class='NT_loader'><div></div></div>");//right side
        var arrowOffset = getElementWidth(linkId) + 11;
        var clickElementx = getAbsoluteLeft(linkId) + arrowOffset; //set x position
    }else{
        // choose the left side
        jQuery("body").append("<div id='NT' style='width:"+params['width']*1+"px'><div id='NT_arrow_right' style='left:"+((params['width']*1)+1)+"px'></div><div id='NT_close_right'>"+title+"</div><div id='NT_copy'><div class='NT_loader'><div></div></div>");//left side
        var clickElementx = getAbsoluteLeft(linkId) - ((params['width']*1) + 15); //set x position
    }

    jQuery('#NT').css({left: clickElementx+"px", top: clickElementy+"px"});
    jQuery('#NT').show();
    jQuery('#NT_copy').load(url);
}

function getElementWidth(objectId) {
    x = document.getElementById(objectId);
    return x.offsetWidth;
}

function getAbsoluteLeft(objectId) {
    // Get an object left position from the upper left viewport corner
    o = document.getElementById(objectId)
    oLeft = o.offsetLeft            // Get left position from the parent object
    while(o.offsetParent!=null) {   // Parse the parent hierarchy up to the document element
        oParent = o.offsetParent    // Get parent object reference
        oLeft += oParent.offsetLeft // Add parent left position
        o = oParent
    }
    return oLeft
}

function getAbsoluteTop(objectId) {
    // Get an object top position from the upper left viewport corner
    o = document.getElementById(objectId)
    oTop = o.offsetTop            // Get top position from the parent object
    while(o.offsetParent!=null) { // Parse the parent hierarchy up to the document element
        oParent = o.offsetParent  // Get parent object reference
        oTop += oParent.offsetTop // Add parent top position
        o = oParent
    }
    return oTop
}

function parseQuery ( query ) {
    var Params = new Object ();
    if ( ! query ) return Params; // return empty object
    var Pairs = query.split(/[;&]/);
    for ( var i = 0; i < Pairs.length; i++ ) {
        var KeyVal = Pairs[i].split('=');
        if ( ! KeyVal || KeyVal.length != 2 ) continue;
        var key = unescape( KeyVal[0] );
        var val = unescape( KeyVal[1] );
        val = val.replace(/\+/g, ' ');
        Params[key] = val;
    }
    return Params;
}

function blockEvents(evt) {
    if(evt.target){
        evt.preventDefault();
    }else{
        evt.returnValue = false;
    }
}